/* Trab_ia.pro - Trabalho de Inteligencia Artificial
   Autores: Carlos Fernando Bella Cruz
            Paulo Jaime */

domains

  codigo       = symbol
  nome         = symbol
  cidade       = symbol
  departamento = symbol
  numero       = symbol
  cor          = symbol
  
  quantidade   = integer
  status       = integer
  peso         = integer
  idade        = integer
  salario      = integer
  media        = integer
  
  list         = integer*
  nomes        = symbol* 

database

  partes (numero, nome, cor, peso, cidade).

predicates

  fornecedores (codigo, nome, status, cidade).
  estoque (departamento, numero, quantidade).
  remessas (codigo, numero, quantidade).
  departamento (departamento, cidade, nome).
  empregados (nome, idade, salario, departamento).

  pergunta1.
  
  pergunta2.
  
  pergunta3.
  
  pergunta4.
  
  pergunta5.
  
  pergunta6.
  
  pergunta7.
  
  pergunta8.
  
  pergunta9.
  
  pergunta10.
  
  pergunta11.
  
  pergunta12. 
  
  pergunta13.
  ganha_mais (salario).     
  
  pergunta14.
  list_empreg (nome, media).  
  
  pergunta15.
  
  pergunta16.
  list_dpto (nomes).
  ganha_mais_8700 (salario, departamento).
  quantas_pessoas (departamento).

  pergunta17.
  
  pergunta18.

  pergunta19.

  pergunta20.
  list_departamento (nomes).
  menor_35 (salario, departamento).
  maior_elemento (list, salario).
  maximo (integer, integer, integer).

  pergunta21.
  maximo_quant (quantidade, quantidade).

  somlist (list, real, integer).
  mostra_nomes (nomes).

clauses

  /* Tabela 1 - Fornecedores. */

  fornecedores (s1, silvio, 20, londres       ).
  fornecedores (s2, joao,   10, paris         ).
  fornecedores (s3, pedro,  30, paris         ).
  fornecedores (s4, carlos, 20, londres       ).
  fornecedores (s5, aldo,   30, rio_de_janeiro).

  /* Tabela 2 - Remessas. */

  remessas (s1, p1, 300).
  remessas (s1, p2, 200).
  remessas (s1, p3, 400).
  remessas (s1, p4, 200).
  remessas (s1, p5, 100).
  remessas (s1, p6, 100).
  remessas (s2, p1, 300).
  remessas (s2, p2, 400).
  remessas (s3, p2, 200).
  remessas (s4, p2, 200).
  remessas (s4, p4, 300).
  remessas (s4, p5, 400).

  /* Tabela 3 - Partes. */

  partes (p1, noz,      vermelho, 12, londres).
  partes (p2, ferrolho, verde,    17, paris  ).
  partes (p3, parafuso, azul,     17, roma   ).
  partes (p4, parafuso, vermelho, 14, londres).
  partes (p5, lata,     azul,     12, paris  ).
  partes (p6, porca,    vermelho, 19, londres).

   /* Tabela 4 - Estoque. */

  estoque (d1, p1, 600).
  estoque (d1, p2, 350).
  estoque (d2, p1, 450).
  estoque (d3, p1, 500).
  estoque (d3, p4, 220).

  /* Tabela 5 - Departamento. */

  departamento (d1, londres,   pedro).
  departamento (d2, sao_paulo, paulo).
  departamento (d3, curitiba,  chico).

  /* Tabela 6 - Empregados. */

  empregados (joao,    34,  8600, d1).
  empregados (pedro,   24,  6300, d2).
  empregados (paulo,   42,  9000, d3).
  empregados (chico,   34,  8500, d2).
  empregados (marcos,  29, 12300, d1).
  empregados (antonio, 31,  7300, d3).
  empregados (carlos,  45,  7500, d1).

  /*******************************************/
  /* Implementacao das perguntas fornecidas. */
  /*******************************************/

  /* Pergunta 1: Listar o numero das partes de toda parte fornecida. */

  pergunta1 :-  partes (Numero, _, _, _, _),
                remessas (_, Numero, _),
                write("Numero: "),
                write(Numero),
                nl,
                fail;
                write("Fim").

  /* Pergunta 2: Listar todos os detalhes de todos os empregados. */

  pergunta2 :- empregados (Nome, Idade, Salario, Departamento),
               write ("Nome: "),
               write (Nome),
               write (" Idade: "),
               write (Idade),
               write (" Salario: "),
               write (Salario),
               write (" Departamento: "),
               write (Departamento),
               nl,
               fail;
               write ("Fim").

  /* Pergunta 3: Listar fornecedores e status para fornecedores finais
                 com status maior que 20. */

  pergunta3 :- fornecedores (_, Nome, Status, _),
               Status > 20,
               write ("Nome: "),
               write (Nome),
               write (" Status: "),
               write (Status),
               nl,
               fail;
               write ("Fim").

  /* Pergunta 4: Listar numero dos fornecedores e nomes de fornecedores
                 que estao em Paris ou tem estatus maior que 20 */

  pergunta4 :- fornecedores (Numero, Nome, _, "paris"),
               write ("Numero: "),
               write (Numero),
               write (" Nome: "),
               write (Nome),
               nl,
               fail.

  pergunta4 :- fornecedores (Numero, Nome, Status, Cidade),
               Status > 20,
               write ("Numero: "),
               write (Numero),
               write (" Nome: "),
               write (Nome),
               nl,
               fail;
               write ("Fim").

  /* Pergunta 5: Listar os numeros das partes que tem peso maior que
                 18 ou estao em Paris ou fornecidas por Joao. */

  pergunta5 :- partes (Numero, _, _, Peso, _),
               Peso > 18,
               write ("Numero: "),
               write (Numero),
               nl,
               fail.
               
  pergunta5 :- partes (Numero, _, _, _, "paris"),
               write ("Numero: "),
               write (Numero),
               nl,
               fail.
               
  pergunta5 :- partes (Numero, Nome, Cor, Peso, Cidade),
               fornecedores (FornNum, "joao", FornStatus, FornCidade),
               remessas (FornNum, PartNum, _),
               partes (PartNum, _, _, _, _),
               write ("Numero: "),
               write (PartNum),
               nl,
               fail;
               write ("Fim").

  /* Pergunta 6: Listar o numero dos fonecedores que fornecem pecas
                 P1 e P2. */

  pergunta6 :- fornecedores (Numero, Nome, Status, Cidade),
               remessas (Numero, p1, _),
               remessas (Numero, p2, _),
               write ("Numero: "),
               write (Numero),
               nl,
               fail;
               write ("Fim").

  /* Pergunta 7: Listar nome e status dos fornecedores que vivem em
                 Londres e fornecem no minimo uma parte vermelha */

  pergunta7 :- fornecedores (Numero, Nome, Status, "londres"),
               remessas (Numero, PartesNum, _),
               partes (PartesNum, _, vermelho, _, _),
               write ("Nome: "),
               write (Nome),
               write (" Status: "),
               write (Status),
               nl,
               fail;
               write ("Fim").

  /* Pergunta 8: Listar numero dos fornecedores que nao estao
                 atualmente fornecendo nenhuma parte */

  pergunta8 :- fornecedores (Numero, Nome, Status, Cidade),
               not (remessas (Numero, _, _)),
               write ("Numero: "),
               write (Numero),
               nl,
               fail;
               write ("Fim").

  /* Pergunta 9: Listar fornecedores (nomes e status) que nao
                 fornecem parte P2. */

  pergunta9 :- fornecedores (Numero, Nome, Status, Cidade),
               not (remessas (Numero, p2, _)),
               write (" Nome: "),
               write (Nome),
               write (" Status: "),
               write (Status),
               nl,
               fail;
               write ("Fim").

  /* Pergunta 10: Listar nomes e localizacoes de fornecedores cujo
                  o status e maior que o de Silvio. */

  pergunta10 :- fornecedores (Numero, Nome, Status, Cidade),
                fornecedores (_, "silvio", SilvStatus, _),
                Status > SilvStatus,
                write (" Nome: "),
                write (Nome),
                write (" Localizacao: "),
                write (Cidade),
                nl,
                fail;
                write ("Fim").

  /* Pergunta 11: Listar nomes, nomes de partes e quantidades
                  fornecidas pelos fornecedores de Londres */

  pergunta11 :- fornecedores (Numero, _, _, "londres"),
                remessas (Numero, RemesNum, Quantidade),
                partes (RemesNum, PartNome, _, _, _),
                write ("Nome: "),
                write (PartNome),
                write (" Quantidade: "),
                write (Quantidade),
                nl,
                fail;
                write ("Fim").

  /* Pergunta 12 - Quantos fornecedores estao em Londres? */
  
     pergunta12 :- findall (Status, fornecedores (_, _, Status, "londres"), L),
                   somlist (L, _, Quant),
                   write ("Quantidade: "),
                   write (Quant).
  
  /* Pergunta 13 - Quantas pessoas ganham mais de $800 no Depto D1? */
  
  pergunta13 :- findall (Salario1, ganha_mais (Salario1), L1),
                somlist (L1, _, Quant1),
                write ("Quantidade: "),
                write (Quant1).
    
  ganha_mais (Retorno) :- empregados (_, _, Salario, "d1"),
                          Salario > 800,
                          Retorno = Salario.

  /* Pergunta 14: Listar os nomes de empregados que tem menos de 25 anos e
                  recebem mais do que o salario medio de todos os empregados. */

  pergunta14 :- findall (Salario2, empregados (_, _, Salario2, _), L2),
                somlist (L2, Res2, Quant2),
                Media = Res2 / Quant2,
                findall (Nome, list_empreg (Nome, Media), L3),
                mostra_nomes (L3),
                write ("Fim\n").
                  
  list_empreg (Retorno, Media) :- empregados (Nome, Idade, Salario, _),
                                  Salario > Media,
                                  Idade < 25,
                                  Retorno = Nome.
                  
  /* Pergunta 15: Para cada parte fornecida, listar o numero da
                  parte e a quantidade fornecida desta peca. */

  pergunta15 :- remessas (FornNum, PartNum, Quantidade),
                write ("Numero: "),
                write (PartNum),
                write (" Quantidade: "),
                write (Quantidade),
                nl,
                fail;
                write ("Fim").

  /* Pergunta 16: Quantas pessoas ganham mais de $8700 em cada Departamento ? */

   pergunta16 :- findall (Depart, departamento (Depart, _, _), L4),
                 list_dpto (L4).

   list_dpto ([]):- !.
   list_dpto ([H|T]) :- write ("Departamento: "),
                        write (H),
                        quantas_pessoas (H),
                        list_dpto (T).

   quantas_pessoas (H) :- findall (Retorno, ganha_mais_8700 (Retorno, H), L5),
                          somlist (L5, _, Quant),
                          write (" Quantidade: "),
                          write (Quant),
                          nl.                         

   ganha_mais_8700 (Retorno, H) :- empregados (_, _, Salario, H),
                                   Salario > 8700,
                                   Retorno = Salario.

  /* Pergunta 17: Inserir a parte  P7 (nome=lavadora, cor=cinza,
                  peso=200, cidade=Santos) */

  pergunta17 :- assert ( partes (p7, lavadora, cinza, 200, santos) ),
                nl,
                write ("parte (p7, lavadora, cinza, 200, santos) inserida"),
                nl.

  /* Pergunta 18: Retornar o salario dos empregados do departamento D1. */

  pergunta18 :- empregados (_, _, Salario, "d1"),
                write ("Salario: "),
                write (Salario),
                nl,
                fail;
                write ("Fim").

  /* Pergunta 19: Listar numeros das partes de todas as partes
                  fornecidas por mais de dois fornecedores */

  pergunta19 :- remessas (FornNum, PartNum, _),
                remessas (FornNum2, PartNum2, _),
                remessas (FornNum3, PartNum3, _),
                FornNum <> FornNum2,
                FornNum <> FornNum3,
                FornNum2 <> FornNum3,
                PartNum = PartNum2,
                PartNum2 = PartNum3,
                write ("Numero: "),
                write (PartNum),
                nl,
                fail;
                write ("Fim").

  /* Pergunta 20: Achar o maximo salario dos empregados com menos de 35 anos 
                  em cada departamento */

   pergunta20 :- findall (Depart, departamento (Depart, _, _), L6),
                 list_departamento (L6),
                 write ("Fim").
                  
   list_departamento ([]) :- !.
   list_departamento ([A|B]) :- write ("Departamento: "),
                                write (A),
                                findall (Salarios, menor_35 (Salarios, A), L7),
                                maior_elemento (L7, Maior),
                                nl,
                                write ("Maior salario de funcionario"),
                                nl,
                                write ("com menos de 35 anos: "),
                                write (Maior),
                                nl,
                                list_departamento (B).

  menor_35 (Remun, H) :-  empregados (_, Idade, Sal, H),
                          Idade < 35,
                          Remun = Sal. 
                         
  maior_elemento ([], Maior):- Maior = 0.
  maior_elemento ([H|T], Maior) :- maior_elemento (T, Posterior),
                                   maximo (H, Posterior, Maior).

  maximo (Result, B, Result) :- Result >= B.
  maximo (A, Result, Result) :- A < Result.                                                                        

  /* Pergunta 21: Achar o departamento, sua localizacao, onde existe pelo menos
                  uma parte cuja quantidade e igual ou maior que a mesma peca
                  fornecida por todos os fornecedores. */
                  
     pergunta21 :- estoque (Departamento, ProdNum, QuantEst),
                   findall (Quantidade, remessas (_, ProdNum, Quantidade), L8),
                   somlist (L8, Soma, _),
                   maximo_quant (QuantEst, Soma), 
                   departamento (Departamento, Cidade, _),
                   write (Departamento, "  ", Cidade),
                   nl,
                   fail;
                   write ("Fim").

  maximo_quant (Result, B) :- Result >= B.

                   
  /* Auxiliares */
  
  /* Soma os elementos e diz quantos foram considerados */
  somlist([], 0, 0).
  somlist([H|T], Som, N) :- somlist(T, S1, N1), Som=H+S1, N=1+N1.
  
  /* Imprime os elementos de uma lista */
  mostra_nomes([]).
  mostra_nomes([_|T]) :- mostra_nomes(T), write(T), nl.

goal
  write ("Pressionar <Enter> para obter as respostas sequencialmente"),
  readln (Pausa),

  write ("Resposta da pergunta numero 1\n"),
  pergunta1,
  write ("\n\n"),
  readln (Pausa1),
  
  write ("Resposta da pergunta numero 2\n"),
  pergunta2,
  write ("\n\n"),
  readln (Pausa2),

  write ("Resposta da pergunta numero 3\n"),
  pergunta3,
  write ("\n\n"),
  readln (Pausa3), 

  write ("Resposta da pergunta numero 4\n"),
  pergunta4,
  write ("\n\n"),
  readln (Pausa4), 

  write ("Resposta da pergunta numero 5\n"),
  pergunta5,
  write ("\n\n"),
  readln (Pausa5),

  write ("Resposta da pergunta numero 6\n"),
  pergunta6,
  write ("\n\n"),
  readln (Pausa6),

  write ("Resposta da pergunta numero 7\n"),
  pergunta7,
  write ("\n\n"),
  readln (Pausa7),

  write ("Resposta da pergunta numero 8\n"),
  pergunta8,
  write ("\n\n"),
  readln (Pausa8),

  write ("Resposta da pergunta numero 9\n"),
  pergunta9,
  write ("\n\n"),
  readln (Pausa9),

  write ("Resposta da pergunta numero 10\n"),
  pergunta10,
  write ("\n\n"),
  readln (Pausa10),
 
  write ("Resposta da pergunta numero 11\n"),
  pergunta11,
  write ("\n\n"),
  readln (Pausa11),

  write ("Resposta da pergunta numero 12\n"),
  pergunta12,
  write ("\n\n"),
  readln (Pausa12),

  write ("Resposta da pergunta numero 13\n"),
  pergunta13,
  write ("\n\n"),
  readln (Pausa13),

  write ("Resposta da pergunta numero 14\n"),
  pergunta14,
  write ("\n\n"),
  readln (Pausa14),

  write ("Resposta da pergunta numero 15\n"),
  pergunta15,
  write ("\n\n"),
  readln (Pausa15),

  write ("Resposta da pergunta numero 16\n"),
  pergunta16,
  write ("\n\n"),
  readln (Pausa16),

  write ("Resposta da pergunta numero 17\n"),
  pergunta17,
  write ("\n\n"),
  readln (Pause17),

  write ("Resposta da pergunta numero 18\n"),
  pergunta18,
  write ("\n\n"),
  readln (Pause18),

  write ("Resposta da pergunta numero 19\n"),
  pergunta19,
  write ("\n\n"),
  readln (Pause19),
  
  write ("Resposta da pergunta numero 20\n"),
  pergunta20,
  write ("\n\n"),
  readln (Pause20),
  
  write ("Reposta da pergunta numero 21\n"),
  pergunta21.
  